<?php

session_start();
ob_start();
$do = isset($_GET['do']) ? $_GET['do'] : "";
$ajaxDoArr = array("add2SimpleReturn");
include("initiateStaticSessionCommingWithCurl.php");
if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
    array_push($ajaxDoArr, $do);
}

if (!in_array($do, $ajaxDoArr)) {
    include("../public/impOpreation.php");
}



include_once("../public/config.php");
include("../library/newUplode/uploadfunctions.php");


require_once('../models/dao/YoutubeLinkDAO.class.php');
require_once('../models/dto/YoutubeLink.class.php');
require_once('../models/mysql/YoutubeLinkMySqlDAO.class.php');
require_once('../models/mysql/ext/YoutubeLinkMySqlExtDAO.class.php');




//get the do the action
$do = $_GET['do'];

$langs = $_SESSION['erp_lang'];
include_once("../views/languages/$langs/success.php");
include_once("../views/languages/$langs/error.php");


if (!in_array($do, $ajaxDoArr)) {
    if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {

    } else {
        $smarty->display("header.html");
    }
}



$youtubeLink = new YoutubeLink();
$youtubeLinkDAO = new YoutubeLinkMySqlDAO();
$youtubeLinkEX = new YoutubeLinkMySqlExtDAO();

$today = date("Y-m-d");
//check and use the condition that suite this action
if (empty($do)) {
    //here the permission check
     $showData = R::findAll('memberships', "request_status = 'accepted' AND isdel = 0");
    $smarty->assign('showData', $showData);
    $smarty->display("agenciesview/add.html");
} elseif ($do == "add") {
    try { 
    
        add();
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 1, 'message' => 'تمت العمليه بنجاح', 'message_en' => 'Success');
            echo json_encode($data);
        } else {
            header("location:?do=sucess");
        }
    } catch (Exception $e) {
        echo $e;
        die();
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 2, 'message' => 'حدث خطأ', 'message_en' => 'Error');
            echo json_encode($data);
        } else {
            header("location:?do=error");
        }
    }
} elseif ($do == "show") {
  
    $sql = "SELECT 
                a.*, 
                u.employeename
            FROM agencies a
           
            LEFT JOIN user u ON a.userid = u.userid 
            WHERE a.isdel = 0 
            
            ORDER BY a.id ";
            
    $showData = R::getAll($sql);
    $smarty->assign('showData', $showData);
    $youtubes = $youtubeLinkDAO->queryAll();
    $smarty->assign("youtubes", $youtubes);

    $smarty->display("agenciesview/show.html");
    $smarty->assign("customCheck", 1);
} elseif ($do == "deleteFinaly") {
    try {
        $id = (int) $_GET['id'];
        deleteFinaly($id);

        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 1, 'message' => 'تمت العمليه بنجاح', 'message_en' => 'Success');
            echo json_encode($data);
        } else {
            header("location:?do=sucess");
        }
    } catch (Exception $e) {
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 2, 'message' => 'حدث خطأ', 'message_en' => 'Error');
            echo json_encode($data);
        } else {
            header("location:?do=error");
        }
    }
} elseif ($do == "edit") { //edit request
    $id = $_GET['id'];
     $members = R::findAll('memberships',"request_status = 'accepted' AND isdel = 0");
    $smarty->assign('members', $members);
    $showData = R::load('agencies', $id);
    $smarty->assign('showData', $showData);
    $smarty->display("agenciesview/edit.html");
} elseif ($do == "update") { //edit update
    try {
        update();
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 1, 'message' => 'تمت العمليه بنجاح', 'message_en' => 'Success');
            echo json_encode($data);
        } else {
            header("location:?do=sucess");
        }
    } catch (Exception $e) {
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 2, 'message' => 'حدث خطأ', 'message_en' => 'Error');
            echo json_encode($data);
        } else {
            header("location:?do=error");
        }
    }
} elseif ($do == "sucess") {
    //here the smarty templates
    $smarty->display("succes.html");
} elseif ($do == "error") {
    //here the smarty templates
    $smarty->display("error.html");
}


$smarty->assign("customValidation", 1);

//here the global templates
if (!in_array($do, $ajaxDoArr)) {
    if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {

    } else {
        $smarty->display("footer.html");
    }
}

/* ===============================
  function in this CONTROLLER
  ================================ */

// add in tenderannouncement tbl
function add() {
    $side = $_POST['side'];
    $agency_date = $_POST['date']; 
    $num = $_POST['num']; 
    $name = $_POST['name'];
    $status = $_POST['status'];
    $comment = $_POST['comment'];
    $membername = $_POST['member_name'];
   
   
     $target_dir = "../upload/agencies/";

    if (!file_exists($target_dir)) {
        mkdir($target_dir, 0777, true);
    }
    $rdispense = R::dispense('agencies');
    $rdispense->the_issuing_entity = $side;
    $rdispense-> name = $name;
    $rdispense->agency_date = $agency_date;
    $rdispense->agency_num = $num;
    $rdispense->status = $status;
    $rdispense->comment = $comment;
    $rdispense->member_name = $membername;
     $images = [];
    foreach ($_FILES['image']['name'] as $key => $val) {
        if ($_FILES['image']['tmp_name'][$key] != "") {
            $imgname = time() . "_" . $_FILES['image']['name'][$key];
            move_uploaded_file($_FILES['image']['tmp_name'][$key], "../upload/agencies/" . $imgname);
            $images[] = $imgname;
        }
    }
    $rdispense->images = implode(',', $images);
    $rdispense->sysDate = date("Y-m-d H:i:s");
    $rdispense->userid = $_SESSION['userid'];
    $rdispense->isdel = 0;
  
    $id = R::store($rdispense);
    return $id;
}

function update() {
    $id = $_POST['id'];
    $side = $_POST['side'];
    $agency_date = $_POST['date']; 
    $num = $_POST['num']; 
    $name = $_POST['name'];
    $status = $_POST['status'];
    $comment = $_POST['comment'];
    $membername = $_POST['member_name'];
    $rupdate = R::load('agencies', $id);
    $rupdate->the_issuing_entity = $side;
    $rupdate->agency_date = $agency_date;
    $rupdate->agency_num = $num;
    $rupdate->name = $name;
    $rupdate->status = $status;
    $rupdate->comment = $comment;
    $rupdate->member_name = $membername;
    function up($input, $old) {
        if (!empty($_FILES[$input]['name'][0])) {
            $files = [];
            foreach ($_FILES[$input]['name'] as $k => $v) {
                $n = time() . "_" . rand(111, 999) . "_" . $v;
                move_uploaded_file($_FILES[$input]['tmp_name'][$k], "../upload/agencies/" . $n);
                $files[] = $n;
            }
            return implode(',', $files);
        }
        return $_POST[$old];
    }
    $rupdate->images   = up('image', 'imageurl');
    $rupdate->isdel = 0;
 
    $id = R::store($rupdate);
}

function deleteFinaly($id) {
    $rtrash = R::load('agencies', $id);
    $imageColumns = [
        'images',
    ];
    foreach ($imageColumns as $column) {
        if (!empty($rtrash->$column)) {
        $files = explode(',', $rtrash->$column);
        foreach ($files as $file) {
                $filePath = '../upload/agencies/' . trim($file);
                if (file_exists($filePath) && is_file($filePath)) {
                    chmod($filePath, 0777);
                    unlink($filePath);
                }
            }
        }
    }
    R::trash($rtrash);
}